const Feature = require('./feature');
const Polygon = require('./polygon');

const Circle = function(ctx, geojson) {
  Feature.call(this, ctx, geojson);
  this.coordinates = this.coordinates.map((ring) => { return ring.slice(0, -1); });
};

Circle.prototype = new Polygon();

//点选圆心c，根据鼠标移动后的位置p计算圆的坐标
Circle.prototype.getCircleVertex = function(ctx, c, p) {
  const radius = Math.sqrt((c.x - p.x) * (c.x - p.x) + (c.y - p.y) * (c.y - p.y));
  const PI = Math.PI;
  const circleVertex = [];
  for (let i = 0; i <= 100; i++) {
    const x = c.x + radius * Math.cos(i * PI / 50);
    const y = c.y + radius * Math.sin(i * PI / 50);
    const lnglat = ctx.map.unproject([x, y]);
    circleVertex.push([lnglat.lng, lnglat.lat]);
  }
  return circleVertex;
};

module.exports = Circle;
